from Resource import *

class Player():
    def __init__(self, screen, terrain):
        self.pos = [screen_width/2, screen_height/2]
        self.width = 18
        self.height = 48
        self.legsRight = (Sequence("playerLeg", 6, 3, self.width, self.height),Sequence("playerLeg", 6, 3, self.width, self.height))
        self.legsLeft = (Sequence("playerLeg", 6, 3, self.width, self.height, moveFrame=(1,2), reversed=True),Sequence("playerLeg", 6, 3, self.width, self.height, moveFrame=(1,2), reversed=True))
        self.legsRight[1].frame = 3
        self.legsLeft[0].frame = 3
        self.speed = 6
        self.fallingSpeed = 0
        self.movement = "standingR"
        self.screen = screen
        self.terrain = terrain

    def draw(self):
        if self.movement == "right":
            self.pos[0] += self.legsRight[0].drawFrame(self.screen, (self.pos[0]+3, self.pos[1]))*self.speed
            self.pos[0] += self.legsRight[1].drawFrame(self.screen, (self.pos[0], self.pos[1]))*self.speed
        elif self.movement == "left":
            self.pos[0] += self.legsLeft[0].drawFrame(self.screen, (self.pos[0]+3, self.pos[1]))*self.speed
            self.pos[0] += self.legsLeft[1].drawFrame(self.screen, (self.pos[0], self.pos[1]))*self.speed
        elif self.movement == "standingR":
            self.legsRight[0].drawAtFrame(self.screen, (self.pos[0]+3, self.pos[1]), 3)
            self.legsRight[0].drawAtFrame(self.screen, self.pos, 3)
        elif self.movement == "standingL":
            self.legsLeft[0].drawAtFrame(self.screen, (self.pos[0] + 3, self.pos[1]), 2)
            self.legsLeft[0].drawAtFrame(self.screen, self.pos, 2)
        if self.pos[0] < self.terrain.start:
            self.pos[0] = self.terrain.start
        elif self.pos[0] > self.terrain.end-self.width:
            self.pos[0] = self.terrain.end-self.width
        self.pos[1] = self.terrain.getHeight(self.pos[0] + self.width / 2) - self.height

    def handleEvent(self, event):
        if event.type == pygame.KEYDOWN:
            if event.key == pygame.K_d:
                self.movement = "right"
            elif event.key == pygame.K_a:
                self.movement = "left"

        if event.type == pygame.KEYUP:
            if event.key == pygame.K_d:
                self.movement = "standingR"
            elif event.key == pygame.K_a:
                self.movement = "standingL"
