from Config import *

class Sequence():
    def __init__(self, image, frames, tickTime, w, h, moveFrame = (3, 4), reversed = False):
        self.image = pygame.image.load("textures\\"+image+".png")
        if reversed:
            self.image = pygame.transform.flip(self.image, True, False)
        self.reversed = reversed
        self.w = w
        self.h = h
        self.tick = 0
        self.tickTime = tickTime
        self.frames = frames
        self.frame = 0
        self.moveFrame = moveFrame

    def drawFrame(self, surface, pos):
        surface.blit(self.image, pos, pygame.Rect(self.frame*self.w, 0, self.w, self.h))
        self.tick += 1
        if self.tick > self.tickTime:
            self.tick = 0
            if self.reversed:
                self.frame -= 1
                if self.frame < 0:
                    self.frame = self.frames-1
            else:
                self.frame += 1
                if self.frame >= self.frames:
                    self.frame = 0
            if self.frame in self.moveFrame:
                if self.reversed:
                    return -1
                return 1
        return 0

    def drawAtFrame(self, surface, pos, frame):
        surface.blit(self.image, pos, pygame.Rect(frame * self.w, 0, self.w, self.h))
