import pygame, sys, random
from jeffsSprite import *

class Cursor(PointSprite):
    def __init__(self, pos, screen):
        Sprite.__init__(self)
        self.length = 15
        self.deltaPos = [0, 0]
        self.pos = pos
        self.center = [pos[0], pos[1]]
        self.points = [(0,0), (self.length/4, self.length),
                       (self.length/3, self.length*3/4), (self.length/3, self.length/3),
                       (self.length*3/4, self.length/3), (self.length, self.length/4),
                       (0, 0)]
        self.screen = screen

    def update(self):
        PointSprite.update(self)

    def updatePos(self, pos = (0, 0)):
        self.center[0] = pos[0]
        self.center[1] = pos[1]
        self.deltaPos[0] = pos[0] - self.pos[0]
        self.deltaPos[1] = pos[1] - self.pos[1]
        self.pos[0] = pos[0]
        self.pos[1] = pos[1]

    def handleEvent(self, event):
        if event.type == pygame.MOUSEBUTTONDOWN:
            self.pressed = True
        elif event.type == pygame.MOUSEBUTTONUP:
            self.pressed = False
        elif event.type == pygame.MOUSEMOTION:
            self.updatePos(pygame.mouse.get_pos())

    def draw(self):
        pygame.draw.polygon(self.screen, 0, self.get_points())
        pygame.draw.polygon(self.screen, -1, self.get_points(), 2)


if __name__ == "__main__":
    screen = pygame.display.set_mode((400, 400))
    cursor = Cursor([pygame.mouse.get_pos()[0], pygame.mouse.get_pos()[1]], screen)
    pygame.mouse.set_visible(False)
    clock = pygame.time.Clock()
    while True:
        screen.fill(-1)
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
                sys.exit()
            cursor.handleEvent(event)
        cursor.update()
        cursor.draw()
        pygame.display.flip()
        clock.tick(30)
