import pygame, random, math



gravity = 0.2
smallerGravity = 0.1
friction = 0.01
speedF = 10
speedVar = 2
fireworkSpeed = 3
fireworkSpeedVar = 2
fireworkcount = 10
particleCount = 50

def subad(num1, num2):
    if num1 <= 0:
        return num1-num2
    return num1+num2

class Particle():
    def __init__(self, screen, x, y, vx, vy, tick, color):
        self.x = x
        self.y = y
        self.vx = vx
        self.vy = vy
        self.time = 0
        self.tick = tick
        self.color = color
        self.timeScale = (self.color[0]/self.tick, self.color[1]/self.tick, self.color[2]/self.tick)
        self.dead = False
        self.screen = screen

    def draw(self):
        self.time += 1
        if self.time > self.tick:
            self.dead = True
        self.vx = subad(self.vx, -friction)
        self.vy -= smallerGravity
        self.x += self.vx
        self.y -= self.vy
        tempColor = (abs(int(self.color[0]-self.time*self.timeScale[0])),abs(int(self.color[1]-self.time*self.timeScale[1])), abs(int(self.color[2]-self.time*self.timeScale[2])))
        self.screen.set_at((int(self.x), int(self.y)), tempColor)
        self.screen.set_at((int(self.x)+1, int(self.y)-1), tempColor)
        self.screen.set_at((int(self.x)+1, int(self.y)+1), tempColor)
        self.screen.set_at((int(self.x)-1, int(self.y)-1), tempColor)
        self.screen.set_at((int(self.x)-1, int(self.y)+1), tempColor)

class FireWork():
    def __init__(self, screen, particles):
        self.x = random.randint(0,400)
        self.y = 400
        self.speed = speedF-speedVar+random.randint(0,speedVar*2)
        self.dead = False
        self.screen = screen
        self.particles = particles

    def draw(self):
        self.speed -= gravity
        self.y -= self.speed
        if self.speed < 0:
            self.onExplode()
            self.x = random.randint(0, 400)
            self.y = 400
            self.speed = speedF - speedVar + random.randint(0, speedVar * 2)

        pygame.draw.circle(self.screen, (255,255,255), (int(self.x),int(self.y)), 3)

    def onExplode(self):
        color = (random.randint(100,255), random.randint(100,255), random.randint(100,255))
        for i in range(particleCount):
            angle = random.random()*math.pi*2
            self.particles.append(Particle(self.screen,self.x,self.y,random.random()*math.cos(angle)*(fireworkSpeed+random.randint(0,fireworkSpeedVar)),random.random()*math.sin(angle)*fireworkSpeed,90,color))

if __name__ == "__main__":
    screen = pygame.display.set_mode((400, 400))
    objects = [FireWork(screen) for i in range(fireworkcount)]
    particles = []
    clock = pygame.time.Clock()
    while True:
        screen.fill((0,0,0))
        lenth = len(objects)
        for i in range(lenth):
            objects[lenth-i-1].draw()
            if objects[lenth-i-1].dead:
                del objects[lenth-i-1]
        lenth = len(particles)
        for i in range(lenth):
            particles[lenth-i-1].draw()
            if particles[lenth-i-1].dead:
                del particles[lenth-i-1]
        pygame.display.flip()
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
        clock.tick(30)