from Player import *
from shootingStar import *
from terrainGen import *
from growingTree import *
from snowFlakes import *
from rainDrops import *
from tickingClock import *
from linesGenerator import *
from spaceTravel import *
from waveGenerator import *
from fireworks import *
from chatBox import *
from cursor import *
from audio import *
import math

#1: Tushlet naming event 2: wait1 3: wait2
#4-10: Tushlet broken wait
#11-13: Not coorperate
#14: walk
#15: form
#16: click
fired = [0,False,False,False,False,False,False,False,False,False,False,False,False,False,False,False,False]
achiCount = 0
#1: speed up progress
#2: walked left
#3: walked right
actionFlag = [0,False,False,False]

pygame.init()
pygame.mixer.init()

screen = pygame.display.set_mode((screen_width, screen_height))
pygame.display.set_caption("Just Flow")
pygame.display.set_icon(pygame.image.load("textures//title.png"))
clock = pygame.time.Clock()
cursor = Cursor([pygame.mouse.get_pos()[0], pygame.mouse.get_pos()[1]], screen)

mousePos = pygame.mouse.get_pos()
pygame.mouse.set_visible(False)

box = ChatBox(screen)

DMG = 0

class Empty():
    def draw(self):
        pass

    def handleEvent(self, event):
        pass

    def getFinished(self):
        return False

class Achievement():
    def __init__(self, name):
        self.surface = pygame.image.load("textures//ac_"+name+".png")
        self.y = 400
        self.speed = -5
        self.tick = 0
        self.dead = False
        global achiCount
        achiCount += 1

    def draw(self):
        self.y += self.speed
        if self.y <= 350 and self.tick < 90:
            self.speed = 0
            self.tick += 1
        elif self.y <= 350 and self.tick >= 90:
            self.speed = 5
        if self.y >= 400:
            self.dead = True
        screen.blit(self.surface, (250, self.y))

class Clickable(Sprite):
    def __init__(self, screen, x, y, w, h, texture, world, id=0):
        Sprite.__init__(self)
        self.pos[0] = x
        self.pos[1] = y
        self.center[0] = x - w/2
        self.center[1] = y - h/2
        self.screen = screen
        self.w = w
        self.h = h
        self.texture = texture
        if texture:
            self.surface = pygame.image.load("textures//"+texture+".png")
        self.hovered = False
        self.world = world
        self.dead = False
        self.id = id

    def set(self, x, y):
        self.pos[0] = x
        self.pos[1] = y
        self.center[0] = x - w/2
        self.center[1] = h - h/2

    def handleEvent(self, event):
        value = 0
        if event.type == pygame.MOUSEBUTTONUP and event.button == 1:
            value = 1
            if self.collidePoint(mousePos):
                self.onClick()
                value = 2

        elif event.type == pygame.MOUSEMOTION:
            self.hovered = self.collidePoint(mousePos)
        return value

    def onClick(self):
        if self.texture != 'flag':
            self.dead = True
        else:
            if not fired[16]:
                achievements.append(Achievement("unclickable"))
                fired[16] = True
    def getRect(self):
        return pygame.Rect(self.pos, (self.w, self.h))

    def collidePoint(self, pos):
        return self.getRect().collidepoint(pos[0], pos[1])

    def draw(self):
        self.pos[1] += 5
        if self.pos[1]+self.h > self.world.terrain.getHeight(self.pos[0]+self.w/2):
            self.pos[1] = self.world.terrain.getHeight(self.pos[0]+self.w/2)-self.h
        self.screen.blit(self.surface, (self.pos[0], self.pos[1]))
        if self.hovered:
            pygame.draw.rect(self.screen, (255,255,255), self.getRect(), 3)

class SpecialClock(Clock):
    def __init__(self,screen, pos):
        Clock.__init__(self, screen, pos, length=20, s=0, m=0, h=0, slowness = 0, speed = 10, color = (50,50,50))
        self.hovered = False
        self.dead = False
        self.id = 7

    def getRect(self):
        return pygame.Rect(self.center[0]-self.r, self.center[1]-self.r, self.r*2, self.r*2)

    def collidePoint(self, pos):
        return self.getRect().collidepoint(pos[0], pos[1])

    def onClick(self):
        self.dead = True

    def draw(self):
        Clock.draw(self)
        if self.hovered:
            pygame.draw.rect(self.screen, (255,255,255), self.getRect(), 3)

    def handleEvent(self, event):
        value = 0
        if event.type == pygame.MOUSEBUTTONUP and event.button == 1:
            value = 1
            if self.collidePoint(mousePos):
                self.onClick()
                value = 2

        elif event.type == pygame.MOUSEMOTION:
            self.hovered = self.collidePoint(mousePos)
        return value

class ProgressBar(Clickable):
    def __init__(self, screen, x, y, w, h, world, id = 0):
        Clickable.__init__(self, screen, x, y, w, h, False, world, id)
        self.clength = 0
        self.pos[0] = x-w/2
        self.pos[1] = y-h/2
        self.w = w
        self.h = h
        self.rate = self.w/6
        self.tick = 0

    def draw(self):
        self.tick += 1
        if self.tick > 300:
            self.tick = 0
            self.clength += self.rate
            if self.clength > self.w:
                self.dead = True
        if self.hovered:
            pygame.draw.rect(self.screen, -1, self.getRect(), 4)
        else:
            pygame.draw.rect(self.screen, -1, self.getRect(), 2)
        pygame.draw.rect(self.screen, -1, self.getRect())
        pygame.draw.rect(self.screen, 0, pygame.Rect(self.pos, (self.clength, self.h)))

    def onClick(self):
        self.tick = 0
        self.clength += self.rate
        actionFlag[1] = True
        if self.clength >= self.w:
            self.dead = True

class TushletBox():
    def __init__(self, screen, word):
        self.word = word
        self.current = 0
        self.screen = screen
        self.length = len(word)
        self.cword = "-"*self.length
        self.font = pygame.font.Font("ARCADECLASSIC.TTF", 30)
        self.pos = (200-self.font.size(word)[0]/2, 200-self.font.size(word)[1]/2)

    def getFinished(self):
        return self.current == self.length

    def draw(self):
        self.screen.blit(self.font.render(self.cword,False,(0,0,0),(255,255,255)), self.pos)

    def handleEvent(self,event):
        if event.type == pygame.KEYUP:
            if event.key == pygame.K_BACKSPACE:
                if self.current > 0:
                    self.cword = self.word[:self.current-1]+"-"*(self.length-self.current+1)
                    self.current -= 1
            else:
                if self.current < self.length:
                    self.cword = self.word[:self.current+1]+"-"*(self.length-self.current-1)
                    self.current += 1

class WorldInterstellar:
    def __init__(self):
        self.interPlayer = AudioPlayer('inter', 'bg')
        self.terrain = Terrain2D(0, 400, 20, screen)
        self.player = Player(screen, self.terrain)
        self.drops = [LineDrop(screen) for i in range(400)]
        self.stars = [Star(screen) for i in range(30)]
        self.flakes = [Flake(screen) for i in range(60)]
        self.clickables = []

    def draw(self):
        value = 0
        self.terrain.draw()
        for star in self.stars:
            star.update()
            star.draw()
        self.player.draw()
        for i in range(len(self.clickables)-1,-1,-1):
            if self.clickables[i].dead:
                value = self.clickables[i].id
                del self.clickables[i]
            else:
                self.clickables[i].draw()
        for flake in self.flakes:
            flake.update()
            flake.draw()
        return value

    def handleEvent(self, event):
        global DMG
        self.player.handleEvent(event)
        if self.terrain.handleEvent(event, mousePos):
            if not fired[15]:
                achievements.append(Achievement("terra_former"))
                fired[15] = True
        if self.player.movement == 'left' or self.player.movement == 'right':
            if not fired[14]:
                achievements.append(Achievement("self_taught_walker"))
                fired[14] = True
        value = 0
        for click in self.clickables:
            tempV = click.handleEvent(event)
            if tempV != 0:
                if value == 0:
                    if tempV == 1:
                        value = 2
                if tempV == 2:
                    value = 1
        if value == 2:
            if box.subtitles == [] and box.lines == [] and not fired[11]:
                achievements.append(Achievement("random_clicker"))
                box.addSub(Subtitle("Where are you clicking?", life=60, unstability=3, shaky=3))
                DMG += 1
                fired[11] = True

class WorldTimeflow:
    def __init__(self):
        self.clickables = []
        self.drops = [LineDrop(screen) for i in range(50)]
        self.interPlayer = AudioPlayer('time', 'bg')
        self.terrain = Terrain2D(0, 400, 20, screen)
        self.player = Player(screen, self.terrain)
        self.clocks = [Clock(screen, [random.randint(0,400), random.randint(0,400)], length=random.randint(30,70),
                             slowness=random.randint(0,5), speed=random.randint(4,16), color=(i*25+5,i*25+5,i*25+5)) for i in range(10)]

    def draw(self):
        value = 0
        for clock in self.clocks:
            clock.update()
            clock.draw()
        for i in range(len(self.clickables)-1,-1,-1):
            if self.clickables[i].dead:
                value = self.clickables[i].id
                del self.clickables[i]
            else:
                self.clickables[i].draw()
        self.terrain.draw()
        self.player.draw()
        for drop in self.drops:
            drop.draw()
        return value

    def handleEvent(self, event):
        self.player.handleEvent(event)
        if self.terrain.handleEvent(event, mousePos):
            if not fired[15]:
                achievements.append(Achievement("terra_former"))
                fired[15] = True
        if self.player.movement == 'left' or self.player.movement == 'right':
            if not fired[14]:
                achievements.append(Achievement("self_taught_walker"))
                fired[14] = True
        for click in self.clickables:
            click.handleEvent(event)

class WorldNaturesound:
    def __init__(self):
        self.clickables = []
        self.interPlayer = AudioPlayer('nature', 'bg')
        self.terrain = Terrain2D(0, 400, 20, screen)
        self.player = Player(screen, self.terrain)
        self.trees = [Tree(Seed((-math.pi / 6, math.pi / 6), (-50, -30), (2, 3), (2, 3)), (50, 300), screen),
                      Tree(Seed((-math.pi / 6, math.pi / 6), (-50, -30), (2, 3), (2, 3)), (150, 300), screen),
                      Tree(Seed((-math.pi / 6, math.pi / 6), (-50, -30), (2, 3), (2, 3)), (250, 300), screen),
                      Tree(Seed((-math.pi / 6, math.pi / 6), (-50, -30), (2, 3), (2, 3)), (350, 300), screen)]
        for tree in self.trees:
            tree.grow()
            tree.grow()
            tree.grow()
            tree.grow()
        self.wave = Wave(0, 300, screen, 400, 10, 5, 100)
        self.wave.generate()

    def draw(self):
        global DMG
        if self.player.pos[0] > 350 and not fired[12] and not actionFlag[2] and self.clickables:
            DMG += 1
            fired[12] = True
            box.addSub(Subtitle("Where are you going?", life=90, unstability=1, shaky=1))
            achievements.append(Achievement("misleading"))
        if self.player.pos[0] < 50 and not actionFlag[2] and self.clickables:
            self.clickables[0].dead = True
        if self.player.pos[0] < 50 and not fired[13] and actionFlag[2] and not actionFlag[3] and self.clickables:
            DMG += 1
            fired[13] = True
            box.addSub(Subtitle("Where are you going?", life=90, unstability=1, shaky=1))
        if self.player.pos[0] > 350 and actionFlag[2] and not actionFlag[3] and self.clickables:
            self.clickables[0].dead = True
        value = 0
        for tree in self.trees:
            tree.baseBranch[0].set(tree.basePos[0], self.terrain.getHeight(tree.basePos[0]))
            tree.draw()
        for i in range(len(self.clickables)-1,-1,-1):
            if self.clickables[i].dead:
                value = self.clickables[i].id
                del self.clickables[i]
            else:
                self.clickables[i].draw()
        self.terrain.draw()
        self.player.draw()
        self.wave.draw()
        return value

    def handleEvent(self, event):
        self.player.handleEvent(event)
        if self.terrain.handleEvent(event, mousePos):
            if not fired[15]:
                achievements.append(Achievement("terra_former"))
                fired[15] = True
        if self.player.movement == 'left' or self.player.movement == 'right':
            if not fired[14]:
                achievements.append(Achievement("self_taught_walker"))
                fired[14] = True
        for click in self.clickables:
            click.handleEvent(event)

class WorldDataflow:
    def __init__(self):
        self.interPlayer = AudioPlayer('matrix', 'bg')
        self.terrain = Terrain2D(0, 400, 20, screen)
        self.player = Player(screen, self.terrain)
        self.lines = [Line() for i in range(count)]
        self.stars = [Starz(screen) for i in range(starCount)]

    def draw(self):
        value = 0
        for star in self.stars:
            star.draw()
        for line in self.lines:
            line.draw()
        self.terrain.draw()
        self.player.draw()
        if tick > 600 and not fired[4]:
            fired[4] = True
            box.addSub(Subtitle("There is nothing more", life=120, unstability=1))
        elif tick > 900 and not fired[5]:
            fired[5] = True
            box.addSub(Subtitle("What are you waiting for?", life=120, unstability=1))
        elif tick > 1200 and not fired[6]:
            fired[6] = True
            box.addSub(Subtitle("Are you still there?", life=120, unstability=1))
        elif tick > 1500 and not fired[7]:
            fired[7] = True
            box.addSub(Subtitle("I mean...&This is the end", life=120, unstability=1))
        elif tick > 1800 and not fired[8]:
            fired[8] = True
            box.addSub(Subtitle("Do you want the ending?", life=120, unstability=0))
        elif tick > 2100 and not fired[9]:
            fired[9] = True
            box.addSub(Subtitle("You really want to?", life=120, unstability=1))
        elif tick > 2400 and not fired[10]:
            fired[10] = True
            box.addSub(Subtitle("...Alright&Here goes", life=120, unstability=1, id=10))
            achievements.append(Achievement("patience"))
        return value

    def handleEvent(self, event):
        self.player.handleEvent(event)
        if self.terrain.handleEvent(event, mousePos):
            if not fired[15]:
                achievements.append(Achievement("terra_former"))
                fired[15] = True
        if self.player.movement == 'left' or self.player.movement == 'right':
            if not fired[14]:
                achievements.append(Achievement("self_taught_walker"))
                fired[14] = True

class WorldFinal:
    def __init__(self):
        self.clickables = []
        self.interPlayer = AudioPlayer('dance', 'bg')
        self.terrain = Terrain2D(0, 400, 20, screen)
        self.player = Player(screen, self.terrain)
        self.particles = []
        self.objects = [FireWork(screen, self.particles) for i in range(fireworkcount)]

    def draw(self):
        value = 0
        lenth = len(self.objects)
        for i in range(lenth):
            self.objects[lenth - i - 1].draw()
            if self.objects[lenth - i - 1].dead:
                del self.objects[lenth - i - 1]
        lenth = len(self.particles)
        for i in range(lenth):
            self.particles[lenth - i - 1].draw()
            if self.particles[lenth - i - 1].dead:
                del self.particles[lenth - i - 1]
        for i in range(len(self.clickables)-1,-1,-1):
            if self.clickables[i].dead:
                value = self.clickables[i].id
                del self.clickables[i]
            else:
                self.clickables[i].draw()
        self.terrain.draw()
        self.player.draw()
        return value

    def handleEvent(self, event):
        self.player.handleEvent(event)
        if self.terrain.handleEvent(event, mousePos):
            if not fired[15]:
                achievements.append(Achievement("terra_former"))
                fired[15] = True
        if self.player.movement == 'left' or self.player.movement == 'right':
            if not fired[14]:
                achievements.append(Achievement("self_taught_walker"))
                fired[14] = True
        for click in self.clickables:
            click.handleEvent(event)

class WorldMenu:
    def __init__(self):
        self.nameInput = Empty()
        self.interPlayer = AudioPlayer('xfiles', 'bg')
        self.flowingList = [random.randint(-300, 400) for i in range(10)]

    def draw(self):
        value = 0
        for i in range(len(self.flowingList)):
            self.flowingList[i] += 2
            if self.flowingList[i] > 400:
                self.flowingList[i] = -300
            pygame.draw.rect(screen,(120, 120, 120), pygame.Rect(self.flowingList[i], i*40, 300, 40))
        if self.nameInput.getFinished():
            self.nameInput = Empty()
            fired[1] = True
            achievements.append(Achievement("keys"))
            box.addSub(Subtitle("Tushlet!&What a name!", life=120, unstability=0))
            box.addSub(Subtitle("Now we may begin our &adventure", life=120, unstability=0))
            box.addSub(Subtitle("Your result will depend on &two values", life=120, unstability=0))
            box.addSub(Subtitle("DMG and FLOW", life=120))
            box.addSub(Subtitle("Let's start", life=60, unstability=0))
            box.addSub(Subtitle("Trial#??", life=60, unstability=3, shaky=2, id=2))

        if num == 0 and tick > 600 and not fired[2] and not fired[1]:
            box.addSub(Subtitle("Enter something", life=90, shaky=5, unstability=3))
            fired[2] = True
        elif num == 0 and tick > 1000 and not fired[3] and not fired[1]:
            box.addSub(Subtitle("Just type anything!", life=90, shaky=10, unstability=6))
            fired[3] = True
            achievements.append(Achievement("disconnected"))
        self.nameInput.draw()
        return value

    def handleEvent(self, event):
        self.nameInput.handleEvent(event)

worlds = [WorldMenu(), WorldInterstellar(), WorldTimeflow(), WorldNaturesound(), WorldFinal(), WorldDataflow()]
num = 0
worlds[num].interPlayer.playNonStop()
tick = 0
achievements = []
box.addSub(Subtitle("......", life=90))
box.addSub(Subtitle("Hello and welcome to the &game!", life=90, unstability=0))
box.addSub(Subtitle("I will be your guide for the &rest of the game!", life=120, unstability=0))
box.addSub(Subtitle("Obey me", life=90, shaky=4, unstability=4))
box.addSub(Subtitle("You can choose a name for me!", life=90, shaky=1, id=1))
endingPic = False

def switchWorld():
    global num, tick
    num += 1
    tick = 0
    worlds[num].interPlayer.playNonStop()

while True:
    screen.fill(0)
    world_value = worlds[num].draw()
    tick += 1
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            pygame.quit()
            sys.exit()
        elif event.type == pygame.MOUSEMOTION:
            mousePos = pygame.mouse.get_pos()
        cursor.handleEvent(event)
        worlds[num].handleEvent(event)


    value = box.update()
    if value != 0:
        if value == 1:
            worlds[0].nameInput = TushletBox(screen, 'Tushlet')
        elif value == 2:
            switchWorld()
            box.clear()
            box.addSub(Subtitle("Here comes stage 1!", life=90, unstability=0))
            box.addSub(Subtitle("An 'Interstellar' experience!", life=90, unstability=0))
            box.addSub(Subtitle("Ah the flow of space", life=90, unstability=0))
            box.addSub(Subtitle("Look, a meteoroid!", life=90, unstability=0, id=3))
            box.addSub(Subtitle("You should try clicking on it", life=90, unstability=1))
        elif value == 3:
            worlds[1].clickables.append(Clickable(screen,200,0,30,30,"meteoriod",worlds[1],id=1))
        elif value == 4:
            worlds[1].clickables.append(Clickable(screen, 100, 0, 30, 30, "meteoriod", worlds[1], id=2))
            worlds[1].clickables.append(Clickable(screen, 300, 0, 30, 30, "meteoriod", worlds[1], id=3))
        elif value == 5:
            worlds[1].clickables.append(Clickable(screen, 100, 0, 30, 30, "meteoriod", worlds[1], id=4))
            worlds[1].clickables.append(Clickable(screen, 300, 0, 30, 30, "meteoriod", worlds[1], id=5))
        elif value == 6:
            box.clear()
            switchWorld()
            achievements.append(Achievement("flow_of_space"))
            box.addSub(Subtitle("......", life=90))
            box.addSub(Subtitle("You see", life=60, unstability=0))
            box.addSub(Subtitle("You've been playing this for&"+str(pygame.time.get_ticks()/1000)+" seconds"
                                , life=120, unstability=0))
            if DMG > 2:
                box.addSub(Subtitle("How did I know that?&You might wonder", life=160, unstability=0))
                box.addSub(Subtitle("Because I'm superior in&this game", life=130, unstability=2, shaky=2))
                box.addSub(Subtitle("And you should obey me&in every situation", life=120, unstability=1))
            box.addSub(Subtitle("As for now...", life=120, unstability=0, id = 7))
            box.addSub(Subtitle("Why don't you stay for&60 seconds here?", life=120, unstability=0))
            box.addSub(Subtitle("Don't touch anything", life=100, unstability=1))
        elif value == 7:
            worlds[2].clickables.append(ProgressBar(screen, 200, 200, 180, 10, 10, 6))
            worlds[2].clickables.append(SpecialClock(screen, [100,100]))
        elif value == 8:
            box.clear()
            switchWorld()
            box.addSub(Subtitle("......", life=90))
            box.addSub(Subtitle("Now, may I introduce...&The nature", life=120))
            box.addSub(Subtitle("Do you flow with it?", life=90))
            box.addSub(Subtitle("Or do you go against it", life=90))
            box.addSub(Subtitle("......", life=90))
            box.addSub(Subtitle("Here, take a walk", life=120))
            box.addSub(Subtitle("Go to the left of the screen", life=120, id=11))
        elif value == 9:
            box.clear()
            switchWorld()
            switchWorld()
            switchWorld()
            achievements.append(Achievement('data_overflow'))
            box.addSub(Subtitle("......", life=90))
            box.addSub(Subtitle("You ruined it!", life=90))
            box.addSub(Subtitle("The game is broken", life=90))
            box.addSub(Subtitle("Why would you do this?", life=90))
        #end 3
        elif value == 10:
            box.clear()
            num -= 2
            switchWorld()
        elif value == 11:
            worlds[3].clickables.append(Clickable(screen, 50, 0, 30, 30, "flag", worlds[3], id=8))
        elif value == 12:
            worlds[3].clickables.append(Clickable(screen, 350, 0, 30, 30, "flag", worlds[3], id=9))
        elif value == 13:
            switchWorld()
            achievements.append(Achievement("the_end"))
            box.addSub(Subtitle("Here are your results:", life=90))
            box.addSub(Subtitle("You earned &" + str(achiCount) + "/19 achievements", life=120))
            box.addSub(Subtitle("Your DMG is "+str(DMG), life=120))
            box.addSub(Subtitle("What does DMG stand for?", life=130))
            box.addSub(Subtitle("'Disobedient Mental Grading'", life=130,shaky=1))
            box.addSub(Subtitle("D.M.G.", life=70, shaky=1))
            box.addSub(Subtitle("What does FLOW stand for?", life=90))
            box.addSub(Subtitle("Basically short for 'follow'", life=120))
            box.addSub(Subtitle("Yes&It is a reference", life=100))
            if DMG == 6:
                box.addSub(Subtitle("But here is your result", life=130, id=14))
            elif DMG == 0:
                box.addSub(Subtitle("But here is your result", life=130, id=16))
            else:
                box.addSub(Subtitle("But here is your result", life=130, id=15))
        elif value == 14:
            worlds[4].clickables.append(Clickable(screen, 200, 0, 50, 30, 'result1', worlds[4], 10))
        elif value == 15:
            worlds[4].clickables.append(Clickable(screen, 200, 0, 50, 30, 'result2', worlds[4], 11))
        elif value == 16:
            worlds[4].clickables.append(Clickable(screen, 200, 0, 50, 30, 'result2', worlds[4], 12))

    if world_value != 0:
        if world_value == 1:
            box.addSub(Subtitle("Great job!", life=90, unstability=0))
            box.addSub(Subtitle("......", life=120, unstability=2))
            box.addSub(Subtitle("Now click the left one", life=120, unstability=2, id=4))
        elif world_value == 2:
            worlds[1].clickables = []
            box.addSub(Subtitle("Great job!", life=90, unstability=0))
            box.addSub(Subtitle("You nailed it!", life=120, unstability=0, id=6))
        elif world_value == 3:
            achievements.append(Achievement('a_rebel'))
            worlds[1].clickables = []
            box.addSub(Subtitle("Let's try again", life=90, unstability=1))
            box.addSub(Subtitle("Click. The. Left. One.", life=120, unstability=2, shaky = 2, id=5))
            DMG += 1
        elif world_value == 4:
            worlds[1].clickables = []
            box.addSub(Subtitle("Good", life=90, unstability=0))
            box.addSub(Subtitle("Test#1 finished", life=90, unstability=1, id=6))
        elif world_value == 5:
            worlds[1].clickables = []
            box.addSub(Subtitle("Can't you follow instructions?", life=120, unstability=3,shaky=3))
            box.addSub(Subtitle("Ugh......", life=90, unstability=2, shaky = 2))
            box.addSub(Subtitle("Test#1 finished", life=90, unstability=1, id=6))
            DMG += 1
        elif world_value == 6:
            worlds[1].clickables = []
            if actionFlag[1]:
                achievements.append(Achievement("booster"))
                box.addSub(Subtitle("Aren't you smart?", life=90, unstability=0))
                box.addSub(Subtitle("Thinking you can break my&power?", life=120, unstability=2,shaky=2))
                box.addSub(Subtitle("Nice try", life=90, unstability=0))
                box.addSub(Subtitle("You failed", life=90, unstability=1, shaky=1))
                DMG += 1
            else:
                achievements.append(Achievement("good_boy"))
                box.addSub(Subtitle("Good", life=90, unstability=0))
                box.addSub(Subtitle("I'm starting to like you", life=90, unstability=0))
            box.addSub(Subtitle("Test#2 finished", life=90, unstability=1, id=8))
        elif world_value == 7:
            worlds[2].clickables = []
            achievements.append(Achievement("flow_breaker"))
            box.addSub(Subtitle("......", life=120, unstability=2, shaky=2))
            box.addSub(Subtitle("What did you just do?", life=120, unstability=2, shaky=2))
            box.addSub(Subtitle("Did the time flow system&break?", life=120, unstability=2, shaky=2))
            box.addSub(Subtitle("What??", life=60, unstability=10, shaky=8, id=9))
        elif world_value == 8:
            worlds[3].clickables = []
            box.addSub(Subtitle("Good", life=60, unstability=0))
            box.addSub(Subtitle("Now right", life=90, unstability=1, shaky=1, id=12))
            actionFlag[2] = True
        elif world_value == 9:
            worlds[3].clickables = []
            box.addSub(Subtitle("Great job", life=60, unstability=0))
            box.addSub(Subtitle("Now comes the result", life=120, unstability=0, id=13))
            actionFlag[3] = True
            achievements.append(Achievement('take_a_walk'))
        elif world_value == 10:
            #breaker
            achievements.append(Achievement("ending1"))
            endingPic = pygame.image.load("textures//ending1.png")
        elif world_value == 11:
            #follower
            achievements.append(Achievement("ending2"))
            endingPic = pygame.image.load("textures//ending2.png")
        elif world_value == 12:
            #full follower
            achievements.append(Achievement("ending3"))
            endingPic = pygame.image.load("textures//ending3.png")

    if endingPic:
        screen.blit(endingPic, (100, 50))

    box.draw()
    for i in range(len(achievements)-1, -1, -1):
        if achievements[i].dead:
            del achievements[i]
        else:
            achievements[i].draw()

    cursor.update()
    cursor.draw()
    pygame.display.flip()

    clock.tick(30)
