import pygame, random, math

rate = 0.1

class LineDrop():
    def __init__(self, screen):
        self.gen()
        self.screen = screen

    def draw(self):
        self.y += self.speed
        self.x += self.xspeed
        pygame.draw.line(self.screen, (200,200,200), (self.x, self.y), (self.x+self.width, self.y+self.length), 4)
        if self.y > 400 or self.x < -400*rate or self.x > 400:
            self.gen()

    def gen(self):
        self.x = random.randint(0, 400)-400*rate
        self.y = random.randint(-400, 0)
        self.length = random.randint(10, 20)
        self.width = self.length*rate
        self.speed = self.length/2
        self.xspeed = self.speed*rate

if __name__ == "__main__":
    screen = pygame.display.set_mode((400, 400))

    drops = [LineDrop(screen) for i in range(500)]
    clock = pygame.time.Clock()

    while True:
        screen.fill((0,0,0))
        for drop in drops:
            drop.draw()
        pygame.display.flip()
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
        clock.tick(30)