import pygame, sys, random
from jeffsSprite import *

pygame.init()

class Star(Sprite):
    def __init__(self, screen):
        Sprite.__init__(self)
        self.pos[1] = random.randint(0, 200)
        self.points = 4
        self.rotationSpeed = 1.0/random.randint(10, 20)
        self.sectionAngle = math.pi/self.points
        self.screen = screen
        self.blink = True

    def draw(self):
        pointlist = []
        for i in range(self.points):
            pointlist.append(
                overlay((self.length * math.cos(self.sectionAngle * 2*i+self.angle), self.length * math.sin(self.sectionAngle * 2*i+self.angle)),
                        self.pos))
            pointlist.append(
                overlay((self.length/3 * math.cos(self.sectionAngle * (2*i+1)+self.angle), self.length/3 * math.sin(self.sectionAngle * (2*i+1)+self.angle)),
                        self.pos))
        pygame.draw.polygon(self.screen, (255,255,255), pointlist)

    def update(self):
        Sprite.update(self)
        self.angle += self.rotationSpeed
        if self.blink:
            if random.randint(0, 400) == 1:
                self.addEvent(3, 5, 7/6.0)
                self.addEvent(3, 5, 6/7.0)

class ShootingStar(Star):
    def __init__(self, screen, speed, gravity):
        Star.__init__(self, screen)
        self.blik = False
        self.vel = [speed, 0]
        self.gravity = gravity

    def update(self):
        Star.update(self)
        self.vel[1] += self.gravity
        self.pos[0] += self.vel[0]
        self.pos[1] += self.vel[1]
        self.resize(1.01)

if __name__ == "__main__":
    screen = pygame.display.set_mode((400, 400))
    clock = pygame.time.Clock()
    stars = [Star(screen) for i in range(80)]
    while True:
        screen.fill((0,0,0))
        for star in stars:
            star.update()
            star.draw()
        pygame.display.flip()
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
                sys.exit()
        clock.tick(30)
