import pygame
from jeffsSprite import *

pygame.init()

class Flake(PointSprite):
    def __init__(self, screen):
        PointSprite.__init__(self)
        self.length = random.randint(5, 10)
        self.points = []
        self.angleSpeed = 0.05/random.randint(1,5)
        for i in range(6):
            self.points.append((self.length*math.cos(i/3.0*math.pi), self.length*math.sin(i/3.0*math.pi)))
        self.screen = screen
        self.angle = 0
        scheme = random.randint(100, 200)
        self.color = (scheme,scheme,scheme)
        self.pos[0] = random.randint(0,self.screen.get_width())
        self.pos[1] = random.randint(-50, self.screen.get_height())
        self.center[0] = self.pos[0]
        self.center[1] = self.pos[1]

    def draw(self):
        for point in self.points:
            pygame.draw.line(self.screen, self.color, self.center, overlay(self.center, point), self.length/2)

    def update(self):
        self.rotate(self.angleSpeed)
        self.move(0, 1)
        if self.pos[1] > self.screen.get_height()+50:
            self.set(random.randint(0,self.screen.get_width()), -50)

if __name__ == "__main__":
    screen = pygame.display.set_mode((400, 400))
    flakes = [Flake(screen) for i in range(60)]
    clock = pygame.time.Clock()
    while True:
        screen.fill((0,0,0))
        for flake in flakes:
            flake.update()
            flake.draw()
        pygame.display.flip()
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
        clock.tick(30)
