from jeffsSprite import*
import pygame, sys

class Clock(PointSprite):
    def __init__(self, screen, pos, length=32, s=0, m=0, h=0, slowness = 0, speed = 10, color = (255,255,255)):
        PointSprite.__init__(self)
        self.center = pos
        self.r = length + 8
        self.sec = s
        self.min = m
        self.hor = h
        self.points = [[0,0], [0,0], [0,0]]
        self.screen = screen
        self.length = (length, length/4*3, length/2)
        self.width = (1,2,3)
        self.slowness = slowness
        self.tick = 0
        self.speed = speed
        self.color = color

    def refresh_points(self):
        sa = self.sec/30.0*math.pi
        ma = self.min/30.0*math.pi
        ha = self.hor/30.0*math.pi
        self.points[0] = [int(math.cos(sa)*self.length[0]), int(math.sin(sa)*self.length[0])]
        self.points[1] = [int(math.cos(ma)*self.length[1]), int(math.sin(ma)*self.length[1])]
        self.points[2] = [int(math.cos(ha)*self.length[2]), int(math.sin(ha)*self.length[2])]

    def draw(self):
        temp = self.get_points()
        pygame.draw.circle(self.screen, self.color, self.center, self.r, self.length[0]/8)
        for i in range(3):
            pygame.draw.line(self.screen, self.color, self.center, temp[i], self.width[i])

    def update(self):
        PointSprite.update(self)
        self.tick += 1
        if self.slowness < self.tick:
            self.tick = 0
            self.sec += self.speed
            self.min += self.speed/60.0
            self.hor += self.speed*5/3600.0
            if self.sec > 59:
                self.sec = 0
        self.refresh_points()


if __name__ == "__main__":
    screen = pygame.display.set_mode((400, 400))
    clock1 = Clock(screen, [200,200])
    clock1.refresh_points()
    clock = pygame.time.Clock()
    while True:
        screen.fill(0)
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
                sys.exit()
        clock1.update()
        clock1.draw()
        pygame.display.flip()
        clock.tick(20)